SystemOrganization addCategory: #'tODE-Workspace'!

TOView subclass: #TOWorkspace
	instanceVariableNames: 'contents selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Workspace'!

!TOWorkspace methodsFor: 'accessing' stamp: 'dkh 5/27/2011 09:46'!
contents

	contents ifNil: [ contents := ''].
	^ contents! !

!TOWorkspace methodsFor: 'accessing' stamp: 'dkh 5/27/2011 09:46'!
contents: anObject
	contents := anObject! !

!TOWorkspace methodsFor: 'rendering' stamp: 'dkh 6/4/2011 16:18'!
renderContentOn: html main: main
	| start end |
	self
		renderControl: [ :id :scrpt | 
			(html textArea)
				id: id;
				columns: (80 max: (self textAreaColumns: self contents));
				rows: (20 max: (self textAreaRows: self contents));
				value: self contents;
				onChange: (scrpt html: [ :h | h render: self contents ]);
				onSelect:
						((html jQuery ajax)
								callback: [ :value | start := value ] value: (JSStream on: 'selectionStart');
								callback: [ :value | end := value ] value: (JSStream on: 'selectionEnd');
								callback: [ :value | selection := value copyFrom: start + 1 to: end ] value: (html jQuery id: id) value;
								yourself).
			html break.
			(html submitButton)
				onClick: (html jQuery ajax callback: [ :value | contents := value ] value: (html jQuery id: id) value);
				with: 'Save'.
			(html cancelButton)
				onClick: ((html jQuery id: id) value: self contents);
				with: 'Cancel'.
			(html submitButton)
				onClick:
						((html jQuery ajax)
								callback: [ :value |  ] value: (html jQuery id: id) value;
								script: [ :s | [ self doit: selection main: main ] on: TOErrorCommand do: [ :ex | main updateCenterSideHistory: s ] ]);
				with: 'Selection doit '.
			(html submitButton)
				onClick:
						((html jQuery ajax)
								callback: [ :value | self inspectit: selection main: main ] value: (html jQuery id: id) value;
								script: [ :s | main updateCenterSideHistory: s ]);
				with: 'Selection inspect '.
			(html submitButton)
				onClick:
						(html jQuery ajax
								script: [ :s | 
									self inspectit: self contents main: main.
									main updateCenterSideHistory: s ]);
				with: 'Inspect contents' ]
		on: html! !

!Object methodsFor: '*tode-workspace' stamp: 'dkh 6/4/2011 07:55'!
renderWorkspaceTabOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main
! !

!Object methodsFor: '*tode-workspace' stamp: 'dkh 5/29/2011 10:57'!
tODEWorksapceTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #workspace;
		rendererClass: TOWorkspace;
		receiver: self;
		label: 'workspace';
		order: 75;
		group: 'development';
		renderSelector: #renderWorkspaceTabOn:spec:tOdeMain:! !
